function b=LDCT(x,m,mm);

% The function implements local DCT transform in 2D with the first mm low-frequency
% set 0.
% x is the image, and must be square
% m is the local size, and must be dividor of size(x)

% Warning: the first mm low-frequency are set 0.

n=size(x,1);

deye=dct(eye(m));
% deye=[zeros(mm,m);deye(mm+1:m,:)];
C=kron(speye(n/m),deye);
b=C*x*C';

deye2=dct(eye(3*m/2));
% deye2=[zeros(floor(mm*3/2),3*m/2);deye2(floor(mm*3/2)+1:3*m/2,:)];
Cnew=spalloc(n,n,m*n+3*m^2/2);
Cnew(1:3*m/2,1:3*m/2)=deye2;
Cnew(3*m/2+1:n-3*m/2,3*m/2+1:n-3*m/2)=kron(speye(n/m-3),deye);
Cnew(n-3*m/2+1:n,n-3*m/2+1:n)=deye2;

b=[b;Cnew*x*Cnew']/sqrt(2);

tmpx=kron(mod(0:n-1,m),ones(n,1));
tmpy=kron(ones(1,n),mod(0:n-1,m)');
%ind=double(sqrt(tmpx.^2+tmpy.^2)>mm);
ind=double(max(abs(tmpx),abs(tmpy))>mm);
b(1:n,1:n)=b(1:n,1:n).*ind;

tmpx=[kron(0:3*m/2-1,ones(n,1)),kron(mod(0:n-1-3*m,m),ones(n,1)),kron(0:3*m/2-1,ones(n,1))];
tmpy=[kron(ones(1,n),(0:3*m/2-1)');kron(ones(1,n),mod(0:n-1-3*m,m)');kron(ones(1,n),(0:3*m/2-1)')];
%ind=double(sqrt(tmpx.^2+tmpy.^2)>mm);
ind=double(max(abs(tmpx),abs(tmpy))>mm);
b(n+1:2*n,1:n)=b(n+1:2*n,1:n).*ind;